#include <avr/io.h>
#include <util/delay.h>

#include "io.h"
#include "card_io.h"

#define	SEG_NB_CHIFFRES 3
unsigned char SEG_compteur[SEG_NB_CHIFFRES]={0,0,0};

#define SEG_DELAY	0

static void SEG_effacer(void){
int i;
for(i=1;i<MAX_LED;i++) LED_set(leds[i]);
}

static int SEG_zero[]={0,1,2,3,4,5,-1};
static int SEG_un[]={1,2,-1};
static int SEG_deux[]={0,1,3,4,6,-1};
static int SEG_trois[]={0,1,2,3,6,-1};
static int SEG_quatre[]={1,2,5,6,-1};
static int SEG_cing[]={0,2,3,5,6,-1};
static int SEG_six[]={0,2,3,4,5,6,-1};
static int SEG_sept[]={0,1,2,-1};
static int SEG_huit[]={0,1,2,3,4,5,6,-1};
static int SEG_neuf[]={0,1,2,3,5,6,-1};

static int *SEG_chiffres[]={SEG_zero,SEG_un,SEG_deux,SEG_trois,SEG_quatre,SEG_cing,SEG_six,SEG_sept,SEG_huit,SEG_neuf};

static void SEG_afficher(int c){
if(c<0 || c>9) return;
int i=0;
while(SEG_chiffres[c][i]>=0){
  LED_unset(leds[SEG_chiffres[c][i]+1]);
  i++;
  }
}

void SEG_init(void){
int i;
outputs_init(OUTPUT_PORTB,OUTPUT_PORTC,OUTPUT_PORTD);
for(i=0;i<MAX_DISPLAY;i++) DISP_set(displays[i]);
for(i=1;i<MAX_LED;i++) LED_set(leds[i]);
}

void SEG_affecter(unsigned char c[]){
int i;
for(i=0;i<SEG_NB_CHIFFRES;i++){
  SEG_compteur[i]=c[i];
  }
}

void SEG_rafraichir(void){
static int index=0;
static unsigned int time=SEG_DELAY;
if(time>0){ time--; return; }
time=SEG_DELAY;
SEG_effacer();
DISP_set(displays[index]);
index++; if(index>=SEG_NB_CHIFFRES) index=0;
DISP_unset(displays[index]);
SEG_afficher(SEG_compteur[index]);
}

void SEG_clignoter(void){
LED_toggle(leds[0]);
}
