/************************
*  Timer handling       *
************************/

#include <stdio.h>
#include <avr/io.h>			// for the input/output register
#include <avr/interrupt.h>  

#include "timer.h"

void timer_init(int prescaler,int nbticks)
{
TCCR1A=0;             // No output pin connected, no PWM mode enabled
TCCR1B=(1<<CTC1);     // No input pin used, do not clear timer counter on compare match
switch(prescaler){
  case 8:
    TCCR1B |= (1<<CS11);
    break;
  case 64:
    TCCR1B |= (1<<CS11 | 11<<CS10);
    break;
  case 256:
    TCCR1B |= (1<<CS12);
    break;
  case 1024:
    TCCR1B |= (1<<CS12 | 1<<CS10);
    break;
  }
OCR1A=nbticks;
TIMSK1=(1<<OCIE1A);   // No overflow mode enabled, no input interrupt, output compare interrupt
}
